pro avred,x,y,nmax,imed,idone
;
; if input 1D array X is sufficiently long it is efficiently convolved
; with a top hat function,resampled to reduce the number of points, and
; output as Y, such that Y haas a mamximum of NMAX points. If X is too short 
; nothing is done, Y is output as X, and IDONE is output as 0.
; If IMED is 1 the convolution is replaced by a median filter.
;
idone=0
n=n_elements(x)
if(n lt 2*nmax)then begin
y=x
goto, c999
endif ; n ge 2*nmax
nfil=n/nmax
evenodd,nfil,iodd
c=fltarr(nfil)
c(*)=1.0
c=c/total(c)
if(imed ne 1)then y=convol(x,c)
if(imed eq 1)then y=median(x,nfil)
nn=nfil/2
if(iodd eq 0)then begin
y=y(nn:n-nn)
n=n-2*nn+1
endif ; iodd eq 0
if(iodd eq 1)then begin
y=y(nn:n-nn-1)
n=n-2*nn
endif ; iodd eq 1
test=lindgen(n)
test1=test/nfil
test1=test1*nfil
ii=where(test1 eq test,nii)
y=y(ii)
;
c999:
;
return
end




