pro compositedriftcorr,beta,tau,signal0_in,signalshoot0_in,sillum0_in,ngrid,$
fromc,toc,nplatc,nplateauc,vigpc,keypc,finepc,pidentc,$
keypointc,fpointc,itransc,echc,$
eytc,eztc,mskc,vigc,tc,signalc,ermsc,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfitc,respcorrc,maskoutc,$
istartexpandc,istopexpandc,$
ipix,backminvthispix,backpredvthispix,ierr,iverbose,chi
;
@common_morepar
save,/xdr,beta,tau,signal0_in,signalshoot0_in,sillum0_in,ngrid,$
fromc,toc,nplatc,nplateauc,vigc,vigpc,keypc,finepc,pidentc,$
keypointc,fpointc,itransc,echc,$
eytc,eztc,mskc,vigc,tc,signalc,ermsc,imodel,isquare,islewmethod,ifinemethod,$
istartexpandc,istopexpandc,$
ipix,backminvthispix,backpredvthispix,iverbose,$
gammaexp,zerobias,betashoot,taushoot,gammaexpshoot,$
betacoeffshoot,betaexpshoot,tauoffsetshoot,tauoffset,betaexp,betacoeff,$
file=!INTDIR+'compositedriftcorr.xdr'		;BUGFIX 15/02/01 BS
;
nmajiter=2 ; number of calls of DRIFTCORR to iteratively 
;            optimise SIGNAL0 and SILLUM0 
;
signal0=signal0_in
signalshoot0=signalshoot0_in
sillum0=sillum0_in
;
iplat1=0
iplat2=nplatc-1
ndetinit=0
nplatinit=0
tplatback=0.0
tplatforward=0.0
nlookback=1
niterc=1
ierr=0
istopexpandfirstc=istopexpandc
;
for iter=0,nmajiter-1 do begin
;
driftcorr,beta,tau,signal0,signalshoot0,sillum0,ngrid,$
fromc,toc,nplatc,nplateauc,vigpc,keypc,finepc,pidentc,$
keypointc,fpointc,itransc,echc,$
eytc,eztc,mskc,vigc,tc,signalc,ermsc,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfitc,modelfitshootc,modelfitslowc,respcorrc,maskoutc,niterc,$
istartexpandc,istopexpandc,istopexpandfirstc,iplat1,iplat2,ndetinit,nplatinit,$
ipix,tplatback,tplatforward,nlookback,backminvthispix,backpredvthispix,ierr,$
iverbose,chi
;
ii=where(maskoutc eq 0 and mskc eq 0,nii)
iii=where(maskoutc(fromc(nplatc-1):toc(nplatc-1)) eq 0,niii)
nnnnn=n_elements(tc)
;
if(nii le 0)then begin
print,'COMPOSITEDRIFTCORR: warning no solution found at all '
goto, c555
endif ; nii le 0
if(niii le 0)then begin
print,'COMPOSITEDRIFTCORR: warning no solution found on last composite plateau'
endif ; niii le 0
;
; ***BUG FOUND 150400 sillum0=respcorrc(nii-1)*modelfitc(nii-1)
; ***BUG FOUND 200400 sillum0=respcorrc(ii(nii-1))*modelfitc(ii(nii-1))
sillum0=respcorrc(nnnnn-1)*modelfitc(nnnnn-1)
;save,/xdr,nplatc,maskoutc,mskc,fromc,toc,respcorrc,modelfitc,$
;modelfitshootc,modelfitslowc,tc,file='diag.xdr'
;***BUG if(imodel eq 1 or imodel eq 2)then signal0=modelfitc(ii(nii-1))  
if(imodel eq 1 or imodel eq 2)then signal0=modelfitc(nnnnn-1)  
; last good point is entry signal to first point
if(imodel eq 3)then begin
; ***BUG FOUND 200400 signalshoot0=modelfitshootc(ii(nii-1))
; ***BUG FOUND 200400 signal0=modelfitslowc(ii(nii-1))
signalshoot0=modelfitshootc(nnnnn-1)
signal0=modelfitslowc(nnnnn-1)
;print,'COMPOSITEDRIFTCORR: signalshoot0,signal0,sillum0 = ',$
;signalshoot0,signal0,sillum0
endif ; imodel eq 3
;
c555:
;
endfor ; iter=0, nmajiter-1
;
return
end






