PRO create_mappar_ft, trans, par

	par = { $
		mapmethod:-1,	$	; Mapping method type
		dropfct:0.3,	$	; Mapping method type
		shx:0.,	$
		shy:0.,	$
		aapin:0,	$	; AAP data present flag
		mapin:0,	$	; maps produced flag
		detector:'',	$	; PHTAAP detector code
		filter:'',	$	; Filter_id
		aper:'',	$	; Aperture_id
		admn:'',	$	; PHTAAP administration string
		admn_decoded:'', $	; admn, decoded string
		aotn:'',	$	; AOT name
		rota:0.,	$	; rotation angle of map
		rota_orig:0.,	$	; rotation angle of map as in AAP
		ra:0.,		$	; right ascension of center of map
		dec:0.,		$	; declination of center of map
		npts:0,		$	; # points per raster line
		nlns:0,		$	; # raster lines
		dpts:0.,	$	; distance of raster points
		dlns:0.,	$	; distance of raster lines
		trans:trans,	$	; transformation structure
		trans_ra:0.,	$	; ra from pia_mapset
		trans_dec:0.,	$	; dec from pia_mapset
		datatype:0,	$	; mean, median, 1st, 3rd quartil
		pixsize:[0.,0.], $	; chosen map pixel size
		npixel:1,	$	; the number of pixels of the detector
		pixselect:[1,1,1,1,1,1,1,1,1], $ ; detector pixel selection
		ffield:0	$	; automatic flat fielding
	}
	RETURN
	END
