pro findgoodarea,maprms,i1,i2,j1,j2
;
; find rectangular area within MAPRMS(0:NYGRID-1,0:NZGRID-1) outside which
; there is no good data. MAPRMS is equal to errflag where there is no good 
; data
;
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
;
@common_mapper
;
i1=0L
i2=nygrid
j1=0L
j2=nzgrid
yarr=lonarr(nygrid)
zarr=lonarr(nzgrid)
for i=0L,nygrid-1 do begin
d1=min(maprms(i,*))
d2=max(maprms(i,*))
if(d2 ne d1)then yarr(i)=i+1 ; there is some data
endfor ; i
for j=0L,nzgrid-1 do begin
d1=min(maprms(*,j))
d2=max(maprms(*,j))
if(d2 ne d1)then zarr(j)=j+1 ; there is some data
endfor ; j
;
i1=min(where(yarr gt 0))
i2=max(where(yarr gt 0))
j1=min(where(zarr gt 0))
j2=max(where(zarr gt 0))
;
return
end
