pro findramp,from,to,jjin,jjout,iramp
;
; input:
;                   TO (integer array dimension NPLAT)
;                      identifier in original input time sequence of LAST 
;                      read in each pointing plateau, including single sample
;                      plateaus taken on the fly. The counter include data
;                      not transmitted.
;                 FROM (integer array dimension NPLAT)
;                      identifier in original input time sequence of FIRST 
;                      sample in each pointing plateau, including single sample
;                      plateaus taken on the fly. The counter include data
;                      not transmitted.
;                 JJIN integer sample identifier of a read 
;
; out:           IRAMP the pointing plateau identifier of the plateau
;                      containing JJIN. If JJIN is greater than the value
;                      of to at the last ramp IRAMP is output as the last ramp
;                JJOUT the identifier of the first sample of plateau IRAMP 
;                      If JJIN is greater than the value
;                      of to at the last ramp JJOUT is output as the last 
;                      sample of the last ramp.
;          
;

itest=jjin-to
ips=where(itest le 0,nips)
if(nips gt 0)then iramp=ips(0) ; first ramp where to(iramp) is ge jjin
;if(nips le 0)then iramp=0 ; no ramps where to(iramp) is ge jjin
if(nips le 0)then iramp=n_elements(to)-1  ; rjt 261099
jjout=from(iramp)
;
return
end