pro model1setup
;
; overwrites that subset of contents of common block DETDEFAULT which
; are used in calculations with IMODEL=1 (foukes-schubert model)
;
; To be called by DETDEFAULT. 
;
; input: ARRAY (common STEERIN)
;
; output: common DETDEFAULT
;
@common_steerin
;common steerin,array,nptin,npt,ninramp,imeas,osamp
@common_detdefault
;common detdefault,betadefault,taudefault,gammaexpdefault,$
;betashootdefault,taushootdefault,gammaexpshootdefault,$
;betacoeffdefault,betaexpdefault,tauoffsetdefault,$
;betacoeffshootdefault,betaexpshootdefault,tauoffsetshootdefault,$
;betaup,betadown,tauup,taudown,gammaexpup,gammaexpdown,$
;betashootup,betashootdown,taushootup,taushootdown,$
;gammaexpshootup,gammaexpshootdown,$
;betacoeffup,betacoeffdown,betaexpup,betaexpdown,$
;tauoffsetup,tauoffsetdown,betacoeffshootup,betacoeffshootdown,$
;betaexpshootup,betaexpshootdown,tauoffsetshootup,tauoffsetshootdown,$
;betaprec,tauprec,gammaexpprec,betashootprec,taushootprec,gammaexpshootprec,$
;betacoeffprec,betaexpprec,tauoffsetprec,$
;betacoeffshootprec,betaexpshootprec,tauoffsetshootprec
;
;if(imodel ne 1)then begin
;print,'MODEL1SETUP: aborting - IMODEL not 1' 
;goto,c999
;endif ; imodel ne 1
;
if(array eq 'c100')then begin
;
betadefault=0.39*[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0] 
betaup(*)=0.99
betadown(*)=0.01
betaprec=0.02
;
taudefault=35.0*[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]
tauup(*)=taudefault(*)*7.0
taudown(*)=taudefault(*)/7.0
tauprec=1.0
;
gammaexpdefault=0.49*[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0] 
gammaexpup(*)=1.5
gammaexpdown(*)=0.25
gammaexpprec=0.1
;
endif ; array eq 'c100'
;
if(array eq 'c200')then begin
;
betadefault=[0.8056,0.8350,0.8075,0.8716] 
betaup(*)=0.99
betadown(*)=0.01 
betaprec=0.02 
;
taudefault=[52.34,24.297,21.15,22.72] 
tauup(*)=taudefault(*)*7.0
taudown(*)=taudefault(*)/7.0
tauprec=1.0
;
gammaexpdefault=0.89*[1.0,1.0,1.0,1.0] 
gammaexpup(*)=1.5
gammaexpdown(*)=0.25
gammaexpprec=0.1
;
endif ; array eq 'c200'
;
c999:
;
return
end





