pro stat,x,xmin,xmax,xmedtrue,xq1,xq3,xsigequiv,xav,xsig,iprint
;
; calculates statistics of input array X and prints them if IPRINT=1
;
n=n_elements(x)
xn=float(n)
xmedtrue=median(x)
xx=x(sort(x))
if(2*(n/2) eq n)then xmedtrue=(xx(n/2)+xx((n/2)-1))/2.0
if(n lt 2)then begin
xq1=xmedtrue
xq3=xq1
endif ; n lt 2
if(n ge 2)then begin ; find quartiles
xnq=(xn-1.0)*0.25  ; lower quartile
nq=ceil(xnq) ; upper integer whether xnq positive or negative 
xnqhi=float(nq)
if(xnqhi eq xnq)then xq1=xx(nq)
if(xnqhi ne xnq)then begin
xoff=xnqhi-xnq
xq1=xoff*xx(nq-1)+(1.0-xoff)*xx(nq)
endif ; float(nq) ne xnq
xnq=(xn-1.0)*0.75 ; upper quartile 
nq=ceil(xnq) ; upper integer whether xnq positive or negative 
xnqhi=float(nq)
if(xnqhi eq xnq)then xq3=xx(nq)
if(xnqhi ne xnq)then begin
xoff=xnqhi-xnq
xq3=xoff*xx(nq-1)+(1.0-xoff)*xx(nq)
endif ; float(nq) ne xnq
endif ; n ge 2
xsigequiv=(xq3-xq1)/(sqrt(2.0)*0.953872) ; errorf(0.476936)=0.5
xmin=min(x)
xmax=max(x)
xav=total(x)/xn
xsig=sqrt((1.0/xn)*total(x*x)-xav*xav)
;
if(iprint eq 1)then begin
print,'min,max,n   = ',xmin,xmax,n
print,'q2,q1,q3,sv = ',xmedtrue,xq1,xq3,xsigequiv
print,'mean,sigma  = ',xav,xsig
endif
;
return
end







