
pro str_event,ev

WIDGET_CONTROL,ev.id,get_uval = uv
if uv eq -1 then return							; text wid event
WIDGET_CONTROL,ev.top,get_uval = info
WIDGET_CONTROL,info.wtext,get_value = user_string			; get contents of text widget
user_string = strtrim(string(user_string,/print),2)
WIDGET_CONTROL,info.storage,set_uval = {select:uv,user:user_string}	; store select type and string
WIDGET_CONTROL,ev.top,/destroy
end

;*******************************************************************************************

function str_query,user_string,$			; out
		 query,$				; in, 
		 init_string, GROUP=group             ; in


IF not KEYWORD_SET(group) THEN group=!PIA_TOP_WID
init_string = strtrim(init_string,2)
xsiz = strlen(init_string) + 10

base = WIDGET_BASE(column=1, Title= "Define Directory for Output files", $
                   /MODAL, Group=group)
   qbase = WIDGET_BASE(base,/row)
      junk = WIDGET_LABEL(qbase,value = query)
      wtext = WIDGET_TEXT(qbase,value = init_string,uval = -1,ysize=1,xsize = xsiz,/editable)
   butbase = WIDGET_BASE(base,/row, space=65)
      junk = WIDGET_BUTTON(butbase,value = '  OK  ',uval = 1,/align_left)
      junk = WIDGET_BUTTON(butbase,value = 'Cancel',uval = 0,/align_center)
      junk = WIDGET_BUTTON(butbase,value = ' Help ',uval = 2,/align_right)

storage = WIDGET_BASE()							; create storage
WIDGET_CONTROL,base,set_uval = {wtext:wtext,storage:storage}		; set up the info

WIDGET_CONTROL,base,/realize
WIDGET_CONTROL,base,tlb_set_xoffset=x,tlb_set_yoffset = y
;WIDGET_CONTROL,base,map=1
wait,0.25
WIDGET_CONTROL,wtext,/input_focus
xmanager,'str',base
WIDGET_CONTROL,storage,get_uval = info,/destroy				; get the uval choice back
user_string = info.user							; copy the string to return it
WIDGET_CONTROL,/hourglass						; put up the hourglass
return,info.select							; return 0 or 1
end
