pro timemapdirection,iy,iz,timeyz,timeref
;
; For an input direction iy,iz on the P32 natural grid finds 
; finds time corresponding to the mean time at which all detector pixels
; view the direction with the OTF set. If not all detector pixels view
; iy,iz, then timeyz is set to 0.0 TIMEREF is output as the mean time
; for which each detector pixel views iy,iz. 
;
@common_wherepoint
;common wherepoint,idy,idz
@common_pinfo
;common pinfo,fpt
@common_steer1
;common_steer1.pro:common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
@common_timer
;common timer,time,dtime,complete
@common_signal
;common_signal.pro:nkf,kf,nkfmax,irelstart,nchopmed,gbad,npolyrms,nrmsmed,$
;sigmaxfract
;
findtime=fltarr(npix)
timeyz=0.0
ifindall=0
;
for ipix=0,npix-1 do begin
ii=where(idy(ipix,*) eq iy and idz(ipix,*) eq iz and fpt eq 1 and $
bad(ipix,*) eq 0,nii)
;if(nii le 0)then goto,c888 ; all pixels must contribute
if(nii gt 0)then begin
ifindall=ifindall+1
findtime(ipix)=total(time(ii))/float(nii)
endif ; nii gt 0
endfor ;  ipix=0,npix-1 
;
; only set timeyz away from inititialisation value of 0.0 if all pixels view
; direction:
if(ifindall eq npix)then timeyz=total(findtime)/float(npix)
timeref=findtime ; set independent of wheher all pixels view direction
;
c888:
;
return
end