pro vigpix,det,xvig
;
; finds vignetting factors XVIG at each postition of a p32 chopper sweep
; det=1 for c100, =2 for c200
; For c100 XVIG is real(9,13)
; For c200 XVIG is real(4,7)
;
if(det eq 1)then begin
dc=15.0D
npix=9
nc2=6 ; number of chop positions at positive amplitude
endif
;
if(det eq 2)then begin
dc=30.0D
npix=4
nc2=3
endif
;
nchpos=2*nc2+1
x=fltarr(npix,nchpos) ; test array of chopper positions to find factors
c=dc*float(lindgen(nchpos)-nchpos/2) ; OK since nchpos always odd
;
x(*,*)=1.0
vignecorr,det,c,x,xcorr
xvig=1.0/xcorr
;
return
end