pro virtual_grid_assign,ra,dec,rpid,iy,iz
;
;  finds index values iy and iz for each ERD data point on a virtual
;  grid of nominal pointing for use in deglitching
;  and detecting responsivity drifts for points with the otf raised.
;
;  input
;  ra and dec are input values of offset from map centre set up by iiph_erd
;  rpid
;  nptin the number of ERD data points per pixel in input data
;  npt the number of ERD data points per pixel in completed readout cycles
;  array the array used
;
;  output
;  iy and iz are virtual raster point identifiers for each ERD data point 
;
;common steerin,array,nptin,npt,ninramp,imeas,osamp
;common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
;
@common_steerin
@common_steer1
;
;
;
return
end
