PRO find_meas, admn, level, posi, tmp=tmp, error=error

@pia_on_line

	posi = -1
	error = 1
	CASE STRUPCASE(level) OF 
	  'ERD': BEGIN
	     type = phterd
	     com = 'pia_load_ierd'
	  END
	  'SRD': BEGIN
	     type = phtsrd
	     com = 'pia_load_isrd'
	  END
	  'SCP': BEGIN
	     type = phtscp
	     com = 'pia_load_iscp'
	  END
	  'SPD': BEGIN
	     type = phtspd
	     com = 'pia_load_ispd'
	  END
	  'AAP': BEGIN
	     type = phtaap
	     com = 'pia_load_iaap'
	  END
	  ELSE: BEGIN
	   MESSAGE, /INFO, 'No matching type, returning'
	   RETURN
	  END
	ENDCASE
	
	ind = where(type.admn EQ admn, n)
	IF n EQ 0 THEN BEGIN
	  MESSAGE, /INFO, 'Measurement ' + dec_admn(admn) + ' not found'
	  RETURN
	ENDIF
	IF n GT 1 THEN BEGIN
	  MESSAGE, /INFO, 'Warning: measurement ' + dec_admn(admn) + $
	     ' present more than one time'
	  MESSAGE, /INFO, ' Taking the first one'
	  ind = ind(0)
	ENDIF
	   
	posi = ind
	error=0
	
	CALL_PROCEDURE, com, type(posi), tmp
	
	RETURN
	END
