;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;+
; NAME:
;	GENCHO
;
; PURPOSE:
;	Definition of the common block GENCHO for inclusion into other routines.  By defining
;	The common block GENCHO contains different flags for driving automatic
;	processing.
;
; CATEGORY:
;       PIA - common block
;
; CALLING SEQUENCE:
;	@gencho
;
; COMMON BLOCK PARAMETERS:
;	gen_(several parameters driving the processing)
;
; MODIFICATION HISTORY:
;	Wrtten by: Carlos GABRIEL(ESA/VILSPA-SAI) 	December 1995
;  OBSOLETE 
;  OBSOLETE   Superseded by gen_choices
;  OBSOLETE 
;
;-

	COMMON gencho, gen_erd, gen_srd, gen_scp, gen_lin, gen_dar, gen_deg, $
			gen_filt, gen_stop, gen_savsrd, gen_savscp, gen_fits, $
			gen_deg2, gen_drft
