PRO multi_apert_norm, mult_aap_str, apert_str, ERROR=error, MESS=mess


@phtapert
@phtppsf


ERROR=0

	nmeas = N_ELEMENTS(mult_aap_str)
; Conditions for running

; more than 3 meas
	IF nmeas LT 4 THEN BEGIN
	  mess = 'Number of measurements less than 4'
	  ERROR=1
	  RETURN
	ENDIF
	
; 180" and 120" must be in
	ind180 = WHERE(STRMID(mult_aap_str.apert_id,0, 3) EQ '180',n180)
	ind120 = WHERE(STRMID(mult_aap_str.apert_id,0, 3) EQ '120',n120)
	
; for the case n180 is twice > probably FCS included
	IF n180 EQ 2 THEN BEGIN
	  rep_str = mult_aap_str(0:nmeas-2)
	  j=0
	  FOR i=0,nmeas-1 do begin 
	    IF ind180(1) NE i THEN BEGIN
	      rep_str(j) = mult_aap_str(i)
	      j=j+1
	    ENDIF 
	  ENDFOR
	  nmeas = nmeas - 1
	  mult_aap_str = rep_str
	  n180 = 1
	  ind180 = ind180(0)
	  MESSAGE, /INFO, 'I suppose that also an FCS measurement was included'
	  MESSAGE, /INFO, 'taking out of the list a 180" measurement'
; more than 3 meas
	  IF nmeas LT 4 THEN BEGIN
	    mess = 'Number of measurements less than 4'
	    ERROR=1
	     RETURN
	  ENDIF
	ENDIF	  
	  
	  
	IF n180 NE 1 or N120 NE 1 THEN BEGIN 	  
	  mess = '1 measurement must be with apert=180" and one with apert=120"'
	  ERROR=1
	  RETURN
	ENDIF
	ind180 = ind180(0)
	ind120 = ind120(0)
	
	apert_str = {bck_all:0., $
			ubck_all:0., $
			src_sig:0., $ 
			src_usig:0., $
			rel_sig:0., $ 
			rel_usig:0., $
			s_to_n:0.}  

	apert_str = replicate(apert_str, nmeas)
		
	m180 = mult_aap_str(ind180(0))
	m120 = mult_aap_str(ind120(0))
	backsig = (m180.sign - m120.sign * m180.ppsf / m120.ppsf) / $
		  (m180.area - m120.area * m180.ppsf / m120.ppsf)
		  
	backsig_unc = backsig * SQRT( (m180.usig/m180.sign)^2 + $
				      (m120.usig/m120.sign)^2 ) 
	
	bck_all = FLTARR(nmeas)
	ubck_all = bck_all
	src_sig = bck_all
	src_usig = bck_all
	rel_sig = bck_all
	rel_usig = bck_all
	s_to_n = bck_all
				      
	FOR i=0,nmeas-1 DO BEGIN
	
	  bck_all(i) = backsig * mult_aap_str(i).area * mult_aap_str(i).corfac
	  ubck_all(i) = backsig_unc * mult_aap_str(i).area * mult_aap_str(i).corfac
	  
	  src_sig(i) = (mult_aap_str(i).sign - bck_all(i)) 
	  
	  src_usig(i) = src_sig(i) * $
	  	SQRT( (mult_aap_str(i).usig)^2 + (ubck_all(i))^2 )
		
	  s_to_n(i) =  mult_aap_str(i).sign /  mult_aap_str(i).usig
	ENDFOR 	
	  
	FOR i=0,nmeas-1 DO BEGIN 
	  rel_sig(i) = src_sig(i) / src_sig(ind180)
	  rel_usig(i) = rel_sig(i) * $
	  	SQRT( (1./s_to_n(i))^2 + (1./s_to_n(ind180))^2 )
	ENDFOR
	
	IF s_to_n(ind180) LT 5 THEN $
	 MESSAGE, /info, $
'WARNING!! The signal to noise in 180" aperture is actually not sufficient'

	IF src_sig(ind180) LT 0. THEN $
	 MESSAGE, /info, $
'WARNING!! Negative background subtracted signal in 180" aperture'

	apert_str.bck_all = bck_all
	apert_str.ubck_all = ubck_all
	apert_str.src_sig = src_sig 
	apert_str.src_usig = src_usig 
	apert_str.rel_sig = rel_sig
	apert_str.rel_usig = rel_usig
	apert_str.s_to_n = s_to_n 
	
	RETURN
	END
	 
	  
	  
