;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;+
; NAME:
;	PHTDYNCAL
;
; PURPOSE:
;	Definition of the common block PHTDYNCAL (Dynamical calibration
;	 structure) for inclusion into other routines.  
;
; CATEGORY:
;       PIA - common block
;
; CALLING SEQUENCE:
;	@phtdyncalib
;
; MODIFICATION HISTORY:
; 	Written by:	Jose Acosta (ISO SOC - VILSPA)  	May 1998
;	dyncalib_first_handle, dyncalib_last_handle and phtdyncalib_desc added
;	Version 7.1
;			
;-
	COMMON PHTDYNCAL, PHTDYNCAL,  $
	  DYNCAL_FIRST_HANDLE, DYNCAL_LAST_HANDLE, PHTDYNCAL_DESC
