FUNCTION  MS_PositAngle,     RA1, Dec1, RA2, Dec2, RefRA, RefDec, RADIAN=RADIAN
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

MS_Conv_RADEC_Rect,   RA1, Dec1, RefRA, RefDec,    $
                          XPos1, YPos1, /GNOMONIC, /ARCSEC

MS_Conv_RADEC_Rect,   RA2, Dec2, RefRA, RefDec,    $
                          XPos2, YPos2, /GNOMONIC, /ARCSEC

DelRA  = XPos2(0) - XPos1(0)
DelDec = YPos2(0) - YPos1(0)

IF (DelDec EQ 0.0)  $
   THEN BEGIN
      IF (DelRA EQ 0.0)  THEN  PA =   0.0
      IF (DelRA GT 0.0)  THEN  PA =  90.0
      IF (DelRA LT 0.0)  THEN  PA = 270.0

      Return , PA
   ENDIF

PA = !RADEG * ATAN (DelRA , DelDec)

IF (PA LT 0.0)  THEN  PA = PA + 360.

IF (Keyword_set (RADIAN))  THEN  PA =  !DTOR * PA

Return, PA
END

