Pro   MS_RADec_PositAngles,    RA, Dec, PositionAngles, RADIAN=RADIAN
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

FORWARD_FUNCTION   MS_PositAngle



NData          =  N_Elements (RA)
PositionAngles =  FLTARR (NData)

RA1    = RA (0:NData-2)
Dec1   = Dec (0:NData-2)
RA2    = RA (1:NData-1)
Dec2   = Dec (1:NData-1)
RefRA  = 0.5 * (RA1(*) + RA2(*))
RefDec = 0.5 * (Dec1(*) + Dec2(*))

FOR i = 0 , NData-2 , 1  DO BEGIN
  PositionAngles (i) = MS_PositAngle (RA1(i), Dec1(i), RA2(i), Dec2(i), RefRA(i), RefDec(i), RADIAN=RADIAN) - 90
ENDFOR

PositionAngles (NData-1) = PositionAngles (NData-2)

NegativIndex = WHERE (PositionAngles LT 0.0 , NNegativ)
IF (NNegativ GT 0)  THEN  PositionAngles (NegativIndex) = PositionAngles (NegativIndex) + 180.0

Return
END









 
