






Pro   PIA_SM_Morph_1D_Process,  Data,  OutData,            $
                         StructElemSize, ScaleLength,      $
                         StructElemScaling,                $
                         Gauss=Gauss, Flat=Flat,           $
                         Zero=Zero,                        $
                         Opening=Opening,                  $
                         Closing=Closing, Cone=Cone,       $
                         TopHat=TopHat,                    $
                         _EXTRA=EXTRA
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

OutData =  Data (*)

If ((NOT  Keyword_set (Opening))  AND  (NOT  Keyword_set (Closing)))  $
   then begin
      If (Keyword_set (Gauss))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                      $
      				    StructElemSize, ScaleLength,         $
                                    StructElemScaling,                   $
      				    /Erosion, /Gauss, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                   $
      				    StructElemSize, ScaleLength,         $
                                    StructElemScaling,                   $
      				    /Dilation, /Gauss, _Extra=Extra
         endif
      If (Keyword_set (Flat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                      $
      				    StructElemSize, ScaleLength,         $
                                    StructElemScaling,                   $
      				    /Erosion, /Flat, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                   $
      				    StructElemSize, ScaleLength,         $
                                    StructElemScaling,                   $
      				    /Dilation, /Flat, _Extra=Extra
         endif
      If (Keyword_set (MexicanHat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /MexicanHat, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /MexicanHat, _Extra=Extra
         endif
   endif


If (Keyword_set (Opening))  $
   then begin
      If (Keyword_set (Zero))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Zero, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Zero, _Extra=Extra
         endif

      If (Keyword_set (Gauss))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Gauss, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Gauss, _Extra=Extra
         endif
      If (Keyword_set (Flat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Flat, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Flat, _Extra=Extra
         endif
      If (Keyword_set (Cone))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Cone, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Cone, _Extra=Extra
         endif
      If (Keyword_set (MexicanHat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /MexicanHat, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /MexicanHat, _Extra=Extra
         endif
   endif



If (Keyword_set (Closing))  $
   then begin
      If (Keyword_set (Zero))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Zero, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Zero, _Extra=Extra
         endif

      If (Keyword_set (Gauss))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				    StructElemSize,  ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Gauss, _EXTRA=EXTRA
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				    StructElemSize, ScaleLength,       $
                                    StructElemScaling,                   $
      				    /Erosion, /Gauss, _EXTRA=EXTRA
         endif
      If (Keyword_set (Flat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				    StructElemSize,  ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Flat, _EXTRA=EXTRA
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				    StructElemSize, ScaleLength,       $
                                    StructElemScaling,                   $
      				    /Erosion, /Flat, _EXTRA=EXTRA
         endif
      If (Keyword_set (Cone))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /Cone, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /Cone, _Extra=Extra
         endif
      If (Keyword_set (MexicanHat))  $
         then begin
      	    PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Dilation, /MexicanHat, _Extra=Extra
      	    PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
      				     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
      				    /Erosion, /MexicanHat, _Extra=Extra
         endif
   endif



If (Keyword_set (TopHat))  $
   then begin
      If (Keyword_set (Gauss))  $
         then begin
            PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Erosion, /Gauss, _Extra=Extra
            PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Dilation, /Gauss, _Extra=Extra
            OutData =  Data(*) - OutData(*)
         endif
      If (Keyword_set (Flat))  $
         then begin
            PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Erosion, /Flat, _Extra=Extra
            PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Dilation, /Flat, _Extra=Extra
            OutData =  Data(*) - OutData(*)
         endif
      If (Keyword_set (Cone))  $
         then begin
            PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Erosion, /Cone, _Extra=Extra
            PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Dilation, /Cone, _Extra=Extra
            OutData =  Data(*) - OutData(*)
         endif
      If (Keyword_set (MexicanHat))  $
         then begin
            PIA_SM_Morph_1D_BasicProcess,  Data,  TmpData,                    $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Erosion, /MexicanHat, _Extra=Extra
            PIA_SM_Morph_1D_BasicProcess,  TmpData,  OutData,                 $
                                     StructElemSize, ScaleLength,      $
                                    StructElemScaling,                   $
                                    /Dilation, /MexicanHat, _Extra=Extra
            OutData =  Data(*) - OutData(*)
         endif
   endif


Return
End








Pro   PIA_SM_Morph_1D_BasicProcess,  Data,  OutData,                         $
                              StructElemSize, StructElemScaleLength,  $
                              StructElemScaling,                      $
                              Gauss=Gauss, Flat=Flat,                 $
                              Circle=Circle, Paraboloid=Paraboloid,   $
                              Cone=Cone, MexicanHat=MexicanHat,       $
                              Inverse=Inverse, Zero=Zero,             $
                              Erosion=Erosion, Dilation=Dilation,     $
                              Median=Median,                          $
                              DEBUG=DEBUG
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

UnsetValue = -99999999.9

NData     = N_Elements (Data)
OutData   = FltArr (NData)
DeltaData = FltArr (NData)


ScaleLength = 1.0
IF (N_Elements (StructElemScaleLength) GT 0)  THEN  ScaleFactor = StructElemScaleLength

StructElemScaleFactor = 1.0
IF (N_Elements (StructElemScaling) GT 0)  THEN  StructElemScaleFactor = StructElemScaling



If ((StructElemSize mod 2) eq 0)    $
   then StructElemSize = StructElemSize + 1

StructElemHalfSize = StructElemSize  /  2
StructElem         = FltArr (StructElemSize)
StructElemAxis     = FltArr (StructElemSize)
StructElemAxis (*) = FIndGen (StructElemSize)
StructElemAxis (*) = (StructElemAxis (*) - Float (StructElemHalfSize)) / ScaleLength


If (Keyword_set (DEBUG))  $
   then begin
      Print, ' <Morph_1D_BasicProcess> StructElemSize = ' , StructElemSize
      Print, ' <Morph_1D_BasicProcess> StructElemScaleLength = ' , StructElemScaleLength
      Print, ' <Morph_1D_BasicProcess> StructElemScaleFactor = ' , StructElemScaleFactor
   endif


OperatedData       = FltArr (NData , StructElemSize)
OperatedData (*,*) = UnsetValue


If (Keyword_set (Zero))  $
   then begin
      StructElem (*) = 0.0
   ENDIF

If (Keyword_set (Gauss))  $
   then begin
      StructElem (*) = 0.0
      StructElem (*) = exp (-0.5 * (StructElemAxis(*) ^ 2))
   endif

If (Keyword_set (Flat))  $
   then begin
      ScaleLength2 = ScaleLength / 2
      FromIndex    = (StructElemHalfSize - ScaleLength2)  >  0
      UntilIndex   = (StructElemHalfSize + ScaleLength2)  <  StructElemSize
      StructElem (*) = 0.0
      StructElem (FromIndex:UntilIndex) = 1.0
   endif

If (Keyword_set (MexicanHat))  $
    then begin
       StructElem (*) = 0.0
       StructElem (*) = (1.0 - StructElemAxis (*)^2) * exp (-0.5 * StructElemAxis(*)^2)
    endif

If (Keyword_set (Circle))  $
    then begin
       StructElemIndex = Where (abs (StructElemAxis(*)) ge 0.0 , NStructAxisElem)
       StructElem (*)  = 0.0
       StructElem (StructElemIndex) = SQRT (1.0 - (StructElemAxis(StructElemIndex) ^ 2))
    endif

If (Keyword_set (Paraboloid))  $
    then begin
       StructElemIndex = Where (abs (StructElemAxis(*)) ge 0.0 , NStructAxisElem)
       StructElem (*) = 0.0
       StructElem (StructElemIndex) = 1.0 - (StructElemAxis(StructElemIndex) ^ 2)
    endif

If (Keyword_set (Cone))  $
    then begin
       StructElemIndex = Where (abs (StructElemAxis(*)) ge 0.0 , NStructAxisElem)
       StructElem (*) = 0.0
       StructElem (StructElemIndex) = 1.0 - Sqrt(StructElemAxis(StructElemIndex) ^ 2)
    endif


StructElem (*) =  StructElemScaleFactor * StructElem (*)


If (Keyword_set (Inverse))  $
   then begin
      MaxStructVal                 = Max (StructElem (StructElemIndex))
      StructElem (StructElemIndex) = -1.0 * (StructElem (StructElemIndex) - MaxStructVal)
   endif



If (Keyword_set (Erosion))  $
   then begin
      Factor = -1.0
   endif

If (Keyword_set (Dilation))  $
   then begin
      Factor = +1.0
   endif

If ((NOT Keyword_set (Erosion))   AND   (NOT Keyword_set (Dilation)))  $
   then begin
      Factor = +1.0
   endif


OperatedData (*,StructElemHalfSize) = Data (*) + (Factor * StructElem(StructElemHalfSize))

For k = 1 , StructElemHalfSize  do begin

   DeltaData (*) = Data (*) + (Factor * StructElem(StructElemHalfSize-k))

   DeltStart = 0
   DeltEnd   = (NData-1) - k

   InsStart  = (+k)              >   0
   InsEnd    = ((NData-1) + k)   <   (NData-1)

   If (Keyword_set (DEBUG))  $
      then begin
         Print, ' <Morph_1D_BasicProcess> InsStart:InsEnd = ' , InsStart, InsEnd
         Print, ' <Morph_1D_BasicProcess> DeltStart:DeltEnd = ' , DeltStart, DeltEnd
      endif

   OperatedData (InsStart:InsEnd , StructElemHalfSize-k) = DeltaData (DeltStart:DeltEnd)




   DeltaData (*) = Data (*) + (Factor * StructElem(StructElemHalfSize+k))

   DeltStart = k
   DeltEnd   = ((NData-1) + k)   <   (NData-1)

   InsStart  = (-k)              >   0
   InsEnd    = ((NData-1) - k)   <   (NData-1)

   If (Keyword_set (DEBUG))  $
      then begin
         Print, ' <Morph_1D_BasicProcess> InsStart:InsEnd = ' , InsStart, InsEnd
         Print, ' <Morph_1D_BasicProcess> DeltStart:DeltEnd = ' , DeltStart, DeltEnd
      endif

   OperatedData (InsStart:InsEnd , StructElemHalfSize+k) = DeltaData (DeltStart:DeltEnd)

EndFor



For i = 0 , NData-1  do begin

   If ((NOT Keyword_set (Erosion))   AND   (NOT Keyword_set (Dilation)))  $
      then begin
         OutData (i) = Max (OperatedData (i,*))
      endif

   If (Keyword_set (Erosion))  $
      then begin
         OutData (i) = Min (OperatedData (i,Where(OperatedData(i,*) gt UnsetValue)))
      endif

   If (Keyword_set (Dilation))  $
      then begin
         OutData (i) = Max (OperatedData (i,*))
      endif

   If (Keyword_set (UseMedian))  $
      then begin
         OutData (i) = Med (OperatedData(i,UseIndex))
      endif


EndFor

Return
End








