common morepar,gammaexp,zerobias,betashoot,taushoot,gammaexpshoot,$
betacoeffshoot,betaexpshoot,tauoffsetshoot,tauoffset,betaexp,betacoeff
;
;
;         GAMMAEXP   (common MOREPAR) detector model constant. For GAMMAEXP=1
;                    the Foukes function is exactly reproduced for IMODEL=1
;                    (subroutine FOUKES). For
;                    GAMMAEXP < 1 the detector changes more rapidly at first, 
;                    thus mimicing the observed tendency for short response
;                    timescales immediately after the flux step, during 
;                    (eg) P32 chopper plateaus of ca. 1/2 second, and long 
;                    timescales thereafter; (eg) on FCS plateaus of ca. 32s.
;                    scales thereafter 
;         ZEROBIAS   (common MOREPAR) illumination level about which noise 
;                    fluctuations 
;                    should have a symetrical relaxation times for positive
;                    and negative fluctuations. This is normally the estimated
;                    background level on the map - the minimum real sky
;                    illumination encountered
;         BETASHOOT,BETACOEFFSHOOT,BETAEXPSHOOT,
;         TAUOFFSETSHOOT,TAUSHOOT,GAMMAEXPSHOOT (common MOREPAR): 
;                    parameters for shooting function.
;         TAUOFFSET  DC offset in tau (fixed by external analysis o FCS -
;                    used only by EXPSHOOT (IMODEL=3))
;         BETAEXP    exponent of illumination in flux dependence of BETA
;                    (fixed by external analysis o FCS - used only by 
;                    EXPSHOOT in IMODEL=3)
;         BETACOEFF  coefficient of flux in flux dependence of BETA (fixed
;                    by external analysis o FCS - used only by EXPSHOOT
;                    in IMODEL=3)
;
;         For imodel=1,2 only gammaexp,zerobias are used
;         For imodel =3 all parameters are used









































