pro drouinit,iplatprevarray,iplatprevprevarray,jjhistfollowarray,$
illhistf,resphistf,resphistslowf,resphistshootf,$
kfinelast,jjhistfollow,iplatprev,iplatprevprev,$
iplatlastfine,tlastfine,nsolve,ipt1,$
nskytry,skytryplat,bestsky,nbestsky,t,ngrid,nplat
;
; initialises arrays prior to entering the main plateau loop 
; in DRIFTCORR.
;
; input: NPLAT NGRID NDIMSKY T
;
; Note that FPOINTWK (and hence also not MASKOUT) is not reset to the input 
; fpoint as we need to keep the
; current definition of the plateau structure, which may have been changed
; in the drift trap, consisstent with the value of nplat and the other
; plateau-dependent arrays. This means, that on re-entering the iplat
; loop in DRIFTCORR a different plateau structure, with posssibly slews
; where there had previously been fine points, may be encountered. This is
; also why we take the illumination history from SKYPASS rather than 
; BESTSKY in the DETINIT routine - if no more than a single chopper sweep
; is used in the initialisation, this should make no difference to the
; history used for the worst case of NLOOKBACK=1.
;
;common testdriftcorr,skyfound,skyfoundfitres,skyfoundnpt,skypass,nskyfound,$
;ndimsky,skyfoundplat,platskyuse
@common_testdriftcorr
;
@common_rms_imp
;common rms_imp,bestrms,bestsolrms
;
nskyfound=lonarr(ngrid) ; initialised to 0
nskytry=nskyfound
skyfound=fltarr(ngrid,ndimsky)
skyfoundfitres=skyfound
skyfoundnpt=skyfound
skyfoundplat=lonarr(ngrid,ndimsky) ; identifier of plateaus used to fill 
;                                    skyfound
skytryplat=skyfoundplat ; identifier of plateaus tried in a search for soln.
platskyuse=lonarr(nplat) ; =1 for plateaus used to make skyfound
;
iplatprevarray=lonarr(nplat) ; plateau identifiers of previous plateaus to
;                            the current plateau for which a solveillum1
;                            was found
iplatprevarray(*)=-1
iplatprevprevarray=iplatprevarray
jjhistfollowarray=iplatprevarray
;
skypass=t
skypass(*)=0.0
illhistf=skypass
resphistf=skypass
resphistslowf=skypass
resphistshootf=skypass
;
bestsky=fltarr(ngrid)
bestrms=bestsky
nbestsky=lonarr(ngrid)
kfinelast=-1
jjhistfollow=ipt1
iplatprev=-1
iplatprevprev=iplatprev
iplatlastfine=-1
tlastfine=t(ipt1)
;
nsolve=-1 ; IDL counter of good plateaus entered (=0 for first)
;
return
end










