pro findnb,beamextent,sx,nxbr,nxb,xgrid
;
; working routine called by CREATEBEAM and SIMUL32
; input beamextent,sx
; output nxb,xgrid
;
nxbr=round(beamextent/sx) ; half radius of beam in units of SKY pixels
nxb=1+2*nxbr ; always odd
xgrid=sx*findgen(nxb)
xgrid=xgrid-sx*float(nxb/2)
;
return
end