pro fluxbright,ratio,ratiod
;
; conversion factors between brightness and flux on P32 natural grid. Multiply
; data in MJy/sterad by RATIO to convert to Jy/map pixel and by RATIOD
; to convert to Jy/detector pixel
;
@common_mapper
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
@common_steer1
;common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
;
arcsperster=(180.0*3600)/!pi
pixa=sgridy*sgridz/(arcsperster*arcsperster) ; pixel size in sterad
ratio=pixa*1.0e+06 ; conversion factor to convert MJy/sterad to Jy/mappixel
pixd=pixsize*pixsize/(arcsperster*arcsperster) ; detector pixel size in sterad
ratiod=pixd*1.0e+06 ; conversion factor to convert MJy/sterad to Jy/detpixel
;
return
end