pro getnlc,x,xcorr
;
; performs exact signal non-linearity correction on the array x(npix,*)
; to output the corrected array xcorr(npix,*), by calling the PIA
; routine GET_RLIN
;
@common_names
;common_names,tdtnam,iseq,dirnam,caldir,cfilter
@common_steerin
;common steerin,array,nptin,npt,ninramp,imeas,osamp
@phterd
;
;if(array eq 'c100')then root=dirnam+'C1'+iseq+tdtnam
;if(array eq 'c200')then root=dirnam+'C2'+iseq+tdtnam
;iscp = root+'.ISCP'
;@phtscp
;print,'GETNONLC: reading ',iscp
;read_iscp,iscp
;ist=n_elements(phtscp.admn)-1
;pia_load_iscp, phtscp(ist), tmp

; CG: use instead of all this unnecessary stuff the data as defined in the 
; entry by looking for the measurement in the ERD buffer 
admnname = STRUPCASE(STRMID(array,0,2)) + iseq + tdtnam
ind = WHERE (phterd.admn EQ admnname, n)
IF n LE 0 THEN BEGIN
  MESSAGE, /INFO, 'Measurement not found in ERD data!'
  RETURN
ENDIF
pia_load_ierd, phterd(ind(0)), tmp
get_rlin,tmp,x,xcorr

;
return
end
