pro qfind,s,nijf,xq1,xq2,xq3
;
; for ss(o:nijf-1) finds quartiles xq1 xq3 and median xq2
;
ss=s(sort(s))
xdiff=float(nijf)/4.0
xn1=xdiff-0.5 ; IDL identifier of 1st quartile 
xn2=xn1+xdiff ; median
xn3=xn2+xdiff ; second quartile
; find quartiles and medians by linear interpolation from nearest neigbours
iq1=floor(xn1)
if(float(iq1) eq xn1)then xq1=ss(iq1)
if(float(iq1) ne xn1)then begin
d1=xn1-float(iq1)
d2=1.0-d1
xq1=d2*ss(iq1)+d1*ss(iq1+1) ; 1st quartile no systematics
endif
iq2=floor(xn2)
if(float(iq2) eq xn2)then xq2=ss(iq2)
if(float(iq2) ne xn2)then begin
d1=xn2-float(iq2)
d2=1.0-d1
xq2=d2*ss(iq2)+d1*ss(iq2+1) 
endif
iq3=floor(xn3)
if(float(iq3) eq xn3)then xq3=ss(iq3) ; 2nd quartile no systematics
if(float(iq3) ne xn3)then begin
d1=xn3-float(iq3)
d2=1.0-d1
xq3=d2*ss(iq3)+d1*ss(iq3+1)
endif
;
return
end
;
