pro rdpar,ndr
;
; find from input: rdstat, nptin, time:
; output: number of reads in ramp ninramp, readout interval dt, 
; the total number of destructive readouts ndr, 
; the data completeness factor complete
; and the number of points within completed readout cycles npt (<= nptin)
;
;common steerin,array,nptin,npt,ninramp,imeas,osamp
;
@common_timer
;common timer,time,dtime,complete
@common_steerin
@common_plotter
;
i=-1
c99:
i=i+1
if(rdstat(i) eq 1)then begin 
ninramp=i+1
goto, c100
endif
goto, c99
c100:
print,'ninramp = ',ninramp
dt=(time(1)-time(0)) ; double as time is double
print,'non-destructive read interval, inverse = ',dt,1.0/dt
dummy=where(rdstat eq 1, ndr)
print,'number of destructive reads = ',ndr
; check there are no non-d reads after last destructive
npt=nptin
if(ndr*ninramp ne nptin)then begin
npt=(nptin/ndr)
npt=npt*ndr
print,'last readout cycle incomplete: reset npt to',npt
endif
complete=dt*float(ninramp)*float(ndr)/time(npt-1)
complete=round(1.0/complete)
complete=1.0/float(complete)
print,'data completeness = ',complete
;
; verify first ninramp points consist of ninramp-1 ndrs followed by a dr
;if(rdstat(ninramp-1) ne 1 )then print,'ramp synchronisation incorrect',$
;rdstat(0:ninramp-1)
;
dtime=dt ; fills incremental time in common block TIME
;
return
end
