pro solveslew,iplatin,iplatout,iplatprev,jj,kk,illhist,resphistf,illhistf,$
itrans,ldsillum0,nplat
;
; on entry:
; - KK is last point of fine pointing immediately preceding slew and 
; - ILLHIST is illumination history from point JJ to KK
; - ILLHISTF is illumination history completely filled up to and 
;   including the IDL identifier KK. 
; - JJ is point froom which the illumination history ILLHIST has been 
;   calculated
; - RESPHISTF is filled until 
; - IPLATPREV is last transmitted plateau with good data from preceding
;   fine pointing
; - IPLATIN first transmitted plateau of slew with good data
; - NPLAT is total number of plateaus
; - NPLATEAU is number of points in each plateau
;
; on exit:
; - KK is last point of slew 
; - IPLATOUT if IPLATOUT is GT IPLATIN then IPLATOUT is first plateau of 
;   fine pointing succeeding slew. Otherwise IPLATOUT is a plateau preceding
;   IPLATIN as forced by GLITCHRECOVER   
; - NPLAT is total number of plateaus after any upgrades within GLITCHRECOVER
; - NPLATEAU updated for any upgrades within GLITCHRECOVER
;
; unchanged:
; - JJ is point froom which the illumination history is to be calculated
; - ITRANS
; - IPLATIN is 
;
;common timer,time,dtime,complete
@common_timer
;
iplat=iplatin-1
c444:
if(iplat ge nplat-1)then goto, c555
iplat=iplat+1
ninplat=nplateau(iplat)
itransplat=itrans(from(iplat):to(iplat))
mplat=mask(from(iplat):to(iplat))
igood=where(mplat eq 0 and itransplat eq 1,nigood)
;
if(nigood ge 1)then begin
kk=from(iplat)-1





endif ; nigood ge 1
;
c555:
;
return
end
