PRO get_caltdep_file, orig_name, tdep_name

	FXBOPEN, unit, !calg+'PTIMEDEP.FITS', 1, hdr
	
	FXBREAD, unit, calgroot, 'CALGROOT'
	ind = WHERE(STRTRIM(calgroot,2) EQ STRTRIM(orig_name,2), nind)
	
	IF nind EQ 0 THEN BEGIN
	   tdep_name = orig_name
	   PRINT, 'Calibration filename not found in PTIMEDEP'
	   RETURN
	ENDIF
	
	FXBREAD, unit, calgtime, 'CALGTIME'
	FXBREAD, unit, calgfile, 'CALGFILE'
	
	
; convert calgtime to be date conform
	dates = STRARR(nind)
		
	FOR I=0, nind-1 DO BEGIN
	 dat0 = STRMID(calgtime(ind(i)),0,2)+1900.
	 dat1 = STRMID(calgtime(ind(i)),2,3)*1.
	 dat2 = STRMID(calgtime(ind(i)),5,2)*1.
	 dat3 = STRMID(calgtime(ind(i)),7,2)*1.	
	 dat4 = STRMID(calgtime(ind(i)),9,2)*1.
	 dat = [dat0,dat1,dat2,dat3,dat4]
	 dates(i) = DATE_CONV(dat, 'STRING')
	ENDFOR
	
	dates = 'For period beginning at '+dates
	
	pia_multchoice, list, elemnames=dates
	
	tdep_name = STRTRIM(calgfile(ind(list)),2)
	
	FXBCLOSE, unit
	FREE_lun, unit
	
	RETURN
	END
	
