;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	PRO CS_INIT 
;+
; NAME:
;       CS_INIT
;
; PURPOSE:
;       Initializes the structure PHTCS defining the contents as
;	a template structure PHTCS_TYPE. It can be used for clearing
;	the whole CS structure, in case this should show as necessary. 
;
; CATEGORY:
;	PIA - initialisation
;
; CALLING SEQUENCE:
;       CS_INIT
;
; INPUTS:
;	None       
;
; OUTPUTS: 
;	None
;
; COMMON BLOCKS:
;	phtcs
;
; SIDE EFFECTS:
;	Values in the phtcs common block are initialised
;
; PROCEDURES USED:
;       PIA LIB: phtcs_init
;
; MODIFICATION HISTORY:
;       Written by:	C. Gabriel
;	Oct 95 Version 3.5
;-

@phtcs
@phtcs_init

END

