;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;+
; NAME:
;	DEGL_RAMPS_INIT
;
; PURPOSE:
;	Deglitch ramps common initializer
;
; CATEGORY:
;	PIA - initializing
;
; CALLING SEQUENCE:
;	DEGL_RAMPS_INIT
;
; INPUTS:
;	(none)
;
; OUTPUTS:
;	(none)
;
; RESTRICTIONS:
;	(none)
;
; COMMON BLOCKS:
;	degl_ramps_cmn
;
; MODIFICATION HISTORY:
;	Written by:	Carlos Gabriel (ESA/VILSPA-SAI)	August 1996
;-
PRO degl_ramps_init

COMMON degl_ramps_cmn, fsig, niter, minp

	fsig=4.5
	niter=4
	minp=12
	
	RETURN
	END	
