;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;+
; NAME:
;	PHTDRIFT
;
; PURPOSE:
;	Definition of the common block PHTDRIFT  for inclusion
;	into other routines.
;
; CATEGORY:
;       PIA - common block
;
; CALLING SEQUENCE:
;	@phtdrift
;
;
; MODIFICATION HISTORY:
; 	Written by:	Carlos Gabriel (ESA/ESTEC) + J Acosta (La Laguna) Oct96
;	V5.x
;
;-
	COMMON PHTDRIFT, PHTDRIFT, DRIFT_FIRST_HANDLE,$
          DRIFT_LAST_HANDLE, PHTDRIFT_DESC
