FUNCTION poly_cheby, xx, ck, range=range
; x should be between -1 and 1, if not use range

IF N_ELEMENTS(range) EQ 2 THEN $ 
   x = (2.*xx -range(1) -range(0))/(range(1)-range(0)) $
ELSE x = xx

nele = N_ELEMENTS(x)
nterm = N_ELEMENTS(ck)

d = FLTARR(nele)
dd = FLTARR(nele)
x2 = 2.*x

d = DBLARR(nele,nterm+2)

For j=nterm-1,1,-1 DO d(*,j) = 2*x*d(*,j+1)-d(*,j+2) + ck(j)
chebev = x*d(*,1) - d(*,2) + ck(0)/2.

return,chebev

END
