PRO dyncalib_meas, time, signal, flux, weight, TINT=tint, QFLAG=qflag, DET =det
;return calibrated signal for a given measurements, 
; signal[INPUT] is the signal array in V/s (npix,nele)
; time[INPUT] time sequence (nele)

@phtdyncaltab

IF N_ELEMENTS(sl_dyncal_tab) EQ 0 THEN read_specal_dyncal

dbltime = sl_dyncal_tab.ltime
ndbltime = N_ELEMENTS(dbltime)


ltime_tmp = ALOG10(time) 
sig_tmp = signal
IF NOT KEYWORD_SET(det) THEN det = 'SL'
npix  = pixel_det(det)
flux = signal * 0.
weight = signal * 0.

;A possible rebinning can be introduced here to treat those cases where
; the integration time per ramp is very small



FOR ipix=0,npix-1 DO BEGIN 
    s_tmp = REFORM(sig_tmp(ipix,*))
    f1 = getfluxdb_time_blin(s_tmp,ltime_tmp,ipix,weight=w1)
    flux(ipix,*) = f1
    weight(ipix,*) = w1
ENDFOR


END
