PRO GET_AVGFLX_DYNR, tmpdata, flux

@phtacc


; In principle this processing should be applied only to raster measurements

;	  get_rastersteps, tmpdata.rpid, raststeps, time=time, rpflag, $
;	   /in_rast, in_rast_pos
;	  get_rpchopstep, raststeps, tmpdata.step, rpchopstep, in_plat_pos

;plat_num = max(rpchopstep)
;plat_pos = rpchopstep

npix = pixel_det(tmpdata.det)

flux   = tmpdata.flux
uflux  = tmpdata.uflux
weight = tmpdata.weight
flag   = tmpdata.flag

get_validflag, tmpdata.flag, 'DYNR', redflag, det=tmpdata.det

taver = FLTARR(npix)
tavun = taver 
tmedi = taver
tq1me = taver
tq3me = taver
tflag = INTARR(npix)
ind_disc = INTARR(tmpdata.sldi)
FOR i=0, tmpdata.sldi-1 DO ind_disc(i)= TOTAL(redflag(*,i))
ind = WHERE(ind_disc EQ 1,nind) 
IF nind GT 1 THEN time = AVG(tmpdata.time(ind))  ELSE time = 0.
	  
FOR ipix=0,npix-1 DO BEGIN
   ind = WHERE (redflag(ipix,*) EQ 0, nc)
   IF nc GT 0 THEN BEGIN
       weight_mean, flux(ipix,ind), uflux(ipix,ind), $
		     avwe, unwe, avsi, set_weight=weight(ipix,ind) 
       taver(ipix) = avwe  
       tavun(ipix) = unwe
       tmedi(ipix) = median(flux(ipix,ind))

       indmed = where(flux(ipix,ind) LT tmedi(ipix),nquart)
       if nquart GT 0 THEN $
	   tq1me(ipix) = median(flux(ipix,ind(indmed)))        $
       ELSE tq1me(ipix) = 0.
       indmed = where(flux(ipix,ind) GE tmedi(ipix),nquart)
       if nquart GT 0 THEN $
           tq3me(ipix) = median(flux(ipix,ind(indmed)))        $
       ELSE tq3me(ipix) = 0.
       IF nc EQ 1 THEN $
	 tflag(ipix) = 1 ELSE $
	 tflag(ipix) = 0
   ENDIF ELSE BEGIN
       taver(ipix) = 0.  
       tavun(ipix) = 0.	
       tmedi(ipix) = 0.
       tq1me(ipix) = 0.
       tq3me(ipix) = 0.
       tflag(ipix) = 2
   ENDELSE
 ENDFOR

  flux = {aver:taver, avun:tavun, medi:tmedi, q1me:tq1me, $
     q3me:tq3me, flag:tflag, time: time}
	   
RETURN
END
