PRO REDUCE_MAP_POS, x_coord, y_coord, bright, uncert, flag, $
		    red_x_coord, red_y_coord, red_bright, red_uncert, red_flag,$
		    tol_dist=tol_dist, verbose=verbose, ERROR=error
		    
		   
	IF not KEYWORD_SET(tol_dist) THEN tol_dist = 0.1
	NTOTAL = N_ELEMENTS(x_coord)
	remain = lindgen(ntotal)
	
	red_x_coord = 0.
	red_y_coord = 0.
	red_bright = 0.
	red_uncert = 0.
	red_flag = 0.
		    
	WHILE ntotal NE 0 DO BEGIN
	
		
	  ind = WHERE(ABS(x_coord(remain) - x_coord(remain(0))) LT tol_dist $
		  AND ABS(y_coord(remain) - y_coord(remain(0))) LT tol_dist, nf)
	  
	  indind = WHERE(flag(remain(ind)) EQ 0, nfound)
		  
	  IF nfound GT 0 THEN BEGIN 
			
		red_x_coord = [red_x_coord, AVG(x_coord(remain(ind(indind))))]
		red_y_coord = [red_y_coord, AVG(y_coord(remain(ind(indind))))]

		weight_mean, bright(remain(ind(indind))), $
			uncert(remain(ind(indind))), $
			tmp_br, tmp_unc, MINNR=3
		
		red_bright = [red_bright, tmp_br]
		red_uncert = [red_uncert, tmp_unc]
		
	   ENDIF

	   remain(ind) = -1
	   indnot = WHERE(remain NE -1, ntotal)
	   IF KEYWORD_SET(verbose) THEN print, ntotal
		
	   IF ntotal NE 0 THEN remain = remain(indnot)
	   
	 ENDWHILE
	 


	 IF N_ELEMENTS(red_x_coord) LT 2 THEN BEGIN
	    error=1
	    RETURN
	 ENDIF ELSE ERROR=0


	 red_x_coord = red_x_coord(1:*)
	 red_y_coord = red_y_coord(1:*)
	 red_bright = red_bright(1:*)
	 red_uncert = red_uncert(1:*)
	 
	 
	 RETURN
	 END	
		
		
