;+
; NAME:
;       PHTSM
; PURPOSE:
;       COMMON blocks for PIA_SM_.. routines
;
; CALLING SEQUENCE:
;       @phtsm
;
; INPUT PARAMETERS:
;
; OPTIONAL INPUT:
;
; OPTIONAL OUTPUT:
;
; RESTRICTIONS:
;
; METHOD:
;
; PROCEDURES USED:
;
; MODIFICATION HISTORY:
;       25JUL1996 RoBaS - created document, first code
;	pia_sm_cmn -> phtsm, according to gen. PIA rules (SB)	August 1996
;	COMMON pia_sm_cmn deleted, obsolete (SB)		August 1996	
;	flg_srccand introduced (SB)				December 1996
;	smp_bckit introduced, smp_snrps deleted (SB)	      	January 1997
;	several modifications (RA)			      	February 1997
;	smp_logfp, smp_objfp deleted (SB)	       	      	February 1997
;       all smp_* values deleted (SB)                           December 1997
;-
COMMON phtsm, smp_vel

flg_pia_1   = 1b
flg_pia_2   = 2b
flg_speed   = 4b
flg_glitch  = 8b
flg_srccand = 16b
flg_source  = 32b
flg_max    = 1+flg_pia_1+flg_pia_2+flg_speed+flg_glitch+flg_srccand+flg_source

