;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!                                                                             !
;! This routine belongs to the PHT Interactive Analysis Package PIA.           !
;!                                                                             !
;! PIA is a joint development by the ESA Astrophysics Division and the ISOPHOT !
;! Consortium led by the Max Planck Institute for Astronomy (MPIA), Heidelberg.! 
;! Contributing ISOPHOT Consortium institutes are DIAS, RAL, AIP, MPIK, and    !
;! MPIA.                                                                       !
;!                                                                             ! 
;! Its use and distribution are free, as long as this header text is not       !
;! removed, or changed. When publishing ISOPHOT Data reduced with this analysis!
;! package, please mention this in the acknowledgement.                        !
;!                                                                             !
;! No warranties for installation/ support/ maintenance are given.             ! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;+
; NAME:
;	SPLITRAMP_PAR_INIT
;
; PURPOSE:
;	Initialize the common block SPLITRAMP_PAR. 
;
; CATEGORY:
;       PIA - I/O
;
; CALLING SEQUENCE:
;	splitramp_par_init
;
; COMMON BLOCKS:
;	@splitramp_par
;
; MODIFICATION HISTORY:
;	Wrtten by: Carlos GABRIEL(ESA/VILSPA) 	May 1997
;	Version 6.3
;
;-
PRO splitramp_par_init

@splitramp_par

	splitramp_par = {model:1, value:2}
	RETURN
	END
